<?php
/**
 * Plugin ciimport
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */
 
/*-----------------------------------------------------------------
// Filtre pour le plan du site
------------------------------------------------------------------*/

// Construit le plan du site (volumetrie rubrique)
// Renvoi le plan a partir d'un tableau des rubriques concernees
// Chaque ligne du tableau passe en parametre de la fonction doit comprendre
// #ARRAY{id_parent,#ID_PARENT,id_rubrique,#ID_RUBRIQUE,titre,#TITRE}
function ciexport_plan($citableau){
	global $citexteplan;
	global $ciarboplan;
	
        // les "premieres" rubriques parentes dans l'arborescence autorisee pour l'auteur
        // doivent jouer le role de secteur
	$rubrestreints = array();
        $parentrestreints = array();
        $parents = array();
        $id_auteur = $GLOBALS['visiteur_session']['id_auteur'];
        if ($id_auteur) {
                $result = sql_select("id_objet", "spip_auteurs_liens", "objet='rubrique' AND id_auteur=".$id_auteur,"","");
                while ($row = sql_fetch($result)){
                        $rubrestreints[] = $row['id_objet'];
                }
                
                if ($rubrestreints){
        		$res = sql_select("DISTINCT id_parent", "spip_rubriques", sql_in("id_rubrique", $rubrestreints),"","id_parent");
                        while ($row = sql_fetch($res)){
                                $parentrestreints[] = $row['id_parent'];
                        }
                        // trier
        		$res2 = sql_select("id_rubrique", "spip_rubriques", sql_in("id_rubrique", $parentrestreints),"","0+titre,titre");
                        while ($row = sql_fetch($res2)){
                                $parents[] = $row['id_rubrique'];
                        }
                }
        }
        
	$ciarboplan = ciexport_arbo_rubriques($citableau);
	$citexteplan = '<ul class="menu-items rubriques">';
        if (!$parents){
            ciexport_enfantplan(0);
        } else {
            foreach ($parents as $parent){
                ciexport_enfantplan($parent);
            }
        }
	$citexteplan .= '</ul>';
	
	return $citexteplan;  
}

// Renvoi un  tableau associant chaque rubrique parente a un tableau de ses rubriques filles
// Chaque ligne du tableau passe en parametre de la fonction doit comprendre
// #ARRAY{id_parent,#ID_PARENT,id_rubrique,#ID_RUBRIQUE,titre,#TITRE}
function ciexport_arbo_rubriques($citableau) {
	$ciarbo = array();
	$cienfants = array();
	$ciparent = 0;
	$row = array();
        
	foreach ($citableau as $row){
		
		if ($ciparent) {
			if ($ciparent!=$row['id_parent']+1) {
					$ciarbo["p".strval($ciparent-1)] = $cienfants;

				$ciparent = $row['id_parent']+1;
				$cienfants = array();
			}
		} else {
			$ciparent = $row['id_parent']+1;
		}
		
		$cienfants[] = array($row['id_rubrique'],$row['titre']);
	}
	// Traiter le dernier lot 
	if ($ciparent) {
		$ciarbo["p".strval($ciparent-1)] = $cienfants;
		$ciparent = $row['id_parent']+1;
		$cienfants = array();
	}

	return $ciarbo;
}

function ciexport_enfantplan($leparent){
	global $id_parent;
	global $id_rubrique;
	static $i = 0;
	global $ciarboplan;
	global $citexteplan;
        
	$i++;
 	$citableau = $ciarboplan["p".strval($leparent)];	
	 	
 	if ($citableau) {
		if ($i > 1)
	 		$citexteplan .= '<ul class="menu-items rubriques">';
		
	 	foreach($citableau as $row) {
			$my_rubrique=$row[0];
			$titre=$row[1];
	
 			$citexteplan .= '<li class="item">';
 			
			$titre = interdire_scripts(supprimer_numero(typo(extraire_multi($titre))));
			$citexteplan .= $titre;
	 		
      			ciexport_enfantplan($my_rubrique);
                        
 			$citexteplan .= '</li>';
		}

		if ($i > 1)
			$citexteplan .= '</ul>';
	
 	}	
	$i=$i-1;
	
	return true;
}
 

?>